import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { EquipmentOrderGoods, EquipmentOrderGoodsParam } from './model';

/**
 * 分页查询商品
 */
export async function pageEquipmentOrderGoods(
  params: EquipmentOrderGoodsParam
) {
  const res = await request.get<ApiResult<PageResult<EquipmentOrderGoods>>>(
    '/apps/equipment-order-goods/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询商品列表
 */
export async function listEquipmentOrderGoods(
  params?: EquipmentOrderGoodsParam
) {
  const res = await request.get<ApiResult<EquipmentOrderGoods[]>>(
    '/apps/equipment-order-goods',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加商品
 */
export async function addEquipmentOrderGoods(data: EquipmentOrderGoods) {
  const res = await request.post<ApiResult<unknown>>(
    '/apps/equipment-order-goods',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改商品
 */
export async function updateEquipmentOrderGoods(data: EquipmentOrderGoods) {
  const res = await request.put<ApiResult<unknown>>(
    '/apps/equipment-order-goods',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除商品
 */
export async function removeEquipmentOrderGoods(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    '/apps/equipment-order-goods/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除商品
 */
export async function removeBatchEquipmentOrderGoods(
  data: (number | undefined)[]
) {
  const res = await request.delete<ApiResult<unknown>>(
    '/apps/equipment-order-goods/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 检查IP是否存在
 */
export async function checkExistence(
  field: string,
  value: string,
  id?: number
) {
  const res = await request.get<ApiResult<unknown>>(
    '/apps/equipment-order-goods/existence',
    {
      params: { field, value, id }
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}
